;------------------------------------------------------------------------------
;
;	DBCS Vector Table for DOS   YASM/NASM
;
; > yasm -fbin -o dbcs_vec.com dbcs_vec.asm
;
;------------------------------------------------------------------------------

	BITS 16
	org	100h

	section .text

_start:
;	check DBCS Vector Table
	push ds
	mov ax,6300h
	int	21h
	jc	no_dbcs_tbl

;	SBCS/DBCS mode ??
	xor ax,ax
	cmp al,byte [ds:si]
	jnz	dbcs_mode
	cmp al,byte [ds:si+1]
	jnz	dbcs_mode

;	SBCS mode
	pop ds
	mov dx,sbcs_msg
	mov	ah,09h
	int	21h
	jmp	done

;	DBCS mode
dbcs_mode:
	pop ds
	mov dx,dbcs_msg
	mov	ah,09h
	int	21h
	jmp	done

no_dbcs_tbl:
	pop ds
	mov dx,nodvt_msg
	mov	ah,09h
	int	21h

done:
	mov	ax,4c00h
	int	21h


	section .data
dbcs_msg	db	'DBCS Vector Table : DBCS mode', 0dh, 0ah, '$'
sbcs_msg	db  'DBCS Vector Table : SBCS mode', 0dh, 0ah, '$'
nodvt_msg	db	'DBCS Vector Table is not supported.', 0dh, 0ah, '$'


	section .bss

